$(function(){
  
  instantiateForm();

  $('#productColor').on('change',function(){
    updateProductVariation(this);
  }).trigger('change');

  $('#productSize').on('change',function(){
    updateProductVariation(this);
  });

  $('#productItem .customField').on('change', function() {
	updateProductVariation(this);
  });

});

Array.prototype.unique = function()
{
	var n = {},r=[];
	for(var i = 0; i < this.length; i++) 
	{
		if (!n[this[i]]) 
		{
			n[this[i]] = true; 
			r.push(this[i]); 
		}
	}
	return r;
}

var productColors = [];
var productSizes = [];
var productPrice = 0;

function instantiateForm() {
  for(var i=0;i<productVariations.length;i++) {
    productColors.push(productVariations[i].productColor);
    productSizes.push(productVariations[i].productSize);
  }
  productColors = productColors.unique();
  productSizes = productSizes.unique();
  for(var i=0;i<productColors.length;i++) {
    $('#productColor').append('<option value="'+productColors[i]+'">'+productColors[i]+'</option>');
  }
  if (productColors.length<2) {
	$('#productColor').parent().parent().hide();
  }

  for(var i=0;i<productSizes.length;i++) {
    $('#productSize').append('<option value="'+productSizes[i]+'">'+productSizes[i]+'</option>');
  }
  if (productSizes.length<2) {
	$('#productSize').parent().parent().hide();
  }
}

function updateProductVariation(el){
  var $field = $(el);
  var productColor = $('#productColor').val();
  var productSize = $('#productSize').val();
  var $customFields = $('#productItem .customField');

  $snipcartAddItem = $('.snipcart-add-item');
  $snipcartAddItem.hide();

  $customFields.each(function() {
  	$this = $(this);
    var handle = $this.attr('data-handle');
	$snipcartAddItem.attr(handle, $this.val());
  });

  $snipcartAddItem
    .filter('[data-item-custom1-value="'+productColor+'"]')
    .filter('[data-item-custom2-value="'+productSize+'"]')
    .show();

  for(var i=0;i<productVariations.length;i++) {
    if (productVariations[i].productColor==productColor && productVariations[i].productSize==productSize) {
      $('#productItem IMG').attr('src',productVariations[i].productImage);
      productPrice = ($('#productItemPrice').attr('data-base-price')*1)+(productVariations[i].priceModifier*1);
      $('#productItemPrice SPAN').html(productPrice.toFixed(2));
    }
  }
}